{$A+,B-,D-,F-,I-,N-,O-,Q-,R-,S-,define co80}

unit TextCrt;

	INTERFACE

uses Crt;

type BorderType = (DoubleBorder, SingleBorder, EmptyBorder);

const
  {$ifdef co80}
    MaxPage  = 3;
    MaxChar  = 80;
    PageSize = 4096;
  {$else}
    MaxPage  = 7;
    MaxChar  = 40;
    PageSize = 2048;
  {$endif}
  MaxLine    = 25;
  VMemory    = $b800;
  ActivePage : Byte = 0;

procedure Colors(Text, Back : Byte);
{ ⠭ 梥 ⥪  䮭 }

procedure BlinkOrBright(Regim : Boolean);
{ Regim = true	- ⠭ ० 栭 ᨬ
  Regim = false - ⠭ ० મ 䮭 }

procedure CursorOn; { 砥  }

procedure CursorOff; { 몫砥  }

procedure PutCursor(Page, x, y : Byte);
{ ⠭   }

procedure GetCursor(Page : Byte; var x, y : Byte);
{ 頥   }

procedure SetTextPage(Page : Byte);
{  ⨢ 㪠 ࠭ }

function GetTextPage : Byte;
{ 頥  ⨢ ࠭ }

procedure MoveToScreen(var Source, Destin; Count : Word);
{ ७ ଠ   }

procedure MoveFromScreen(var Source, Destin; Count : Word);
{ ⠥    }

procedure MoveScreen(Source, Destin : Byte);
{   ࠭   }

procedure PutScreen(var Source; Page : Byte);
{  ࠭  ⨢    }

procedure GetScreen(var Destin; Page : Byte);
{  ࠭  ⨢  }

procedure PutChar(Page : Byte; cr : Char);
{ 뢠 ᨬ  , 㪠뢠 ஬ }

procedure GetChar(Page : Byte;
	var cr : Char; var Attr : Byte);
{ ⠥ ᨬ    ਡ }

procedure PutAttr(Page, Attr : Byte; Count : Word);
{  ਡ ᪮쪨 ᨬ }

procedure CopyChar(Page : Byte; cr : Char;
	Attr : Byte; Count : Word);
{ 뢠 ᪮쪮  ᨬ }

procedure Border(x1, y1, x2, y2 : Integer; Bord : BorderType);
{  ࠬ   ⥪⮢ ࠭ }

procedure SetWindow(x1, y1, x2, y2 : Integer;
	Bord : BorderType);
{    㫥 ࠭   ࠬ }

procedure PutWindow(x1, y1, x2, y2, Text, Back : Byte;
	Bord : BorderType; Page : Byte);
{ ࠭ 㫥 ࠭  ,  㫥
  ࠭ ᮧ     ࠬ }

procedure GetWindow(Page : Byte);
{ ⠭ ﭨ ࠭, 襥 ।
  饭  楤 PutWindow }

	IMPLEMENTATION

type
  ScreenAttrType = record case Byte of
    0: (Buf : array [1..7] of Byte);
    1: (WindMinSave, WindMaxSave : Word;
	x, y, AttrSave : Byte);
    2: (y1, x1, y2, x2 : Byte)
  end;

const SizeVM = PageSize*(MaxPage+1)-1;

var
  ScreenAttr : array [0..MaxPage] of ScreenAttrType;
  VM : array [0..SizeVM] of Byte absolute VMemory:$0000;

procedure Colors(Text, Back : Byte);
begin
  TextColor(Text); TextBackGround(Back)
end;

procedure BlinkOrBright(Regim : Boolean); assembler;
asm
	mov	ax,1003h
	mov	bl,Regim
	int	10h
end;

procedure CursorOn; assembler;
asm
	mov	ah,1
	mov	cx,607h
	int	10h
end;

procedure CursorOff; assembler;
asm
	mov	ah,1
	mov	ch,20h
	int	10h
end;

procedure PutCursor(Page, x, y : Byte); assembler;
asm
	mov	al,Page
	cmp	al,MaxPage
	jae	@x0
	mov	ah,2
	mov	dh,y
	mov	dl,x
	dec	dl
	dec	dh
	mov	bh,Page
	int	10h
@x0:
end;

procedure GetCursor(Page : Byte; var x, y : Byte); assembler;
asm
	mov	al,Page
	cmp	al,MaxPage
	jae	@x0
	mov	ah,3
	mov	bh,Page
	int	10h
	inc	dl
	inc	dh
	mov	al,dl
	les	di,x
	stosb
	mov	al,dh
	les	di,y
	stosb
@x0:
end;

procedure SetTextPage(Page : Byte); assembler;
asm
	mov	al,Page
	cmp	al,MaxPage
	jae	@x0
	mov	ActivePage,al
	mov	ah,5
	int	10h
@x0:
end;

function GetTextPage : Byte; assembler;
asm
	mov	al,ActivePage
end;

procedure MoveToScreen(var Source, Destin;
	Count : Word); assembler;
asm
	mov	bp,sp
	push	bp
	push	ds
	mov	bh,ds:CheckSnow
	lds	si,Source
	les	di,Destin
	mov	cx,Count
	jcxz	@x0
	cmp	si,di
	jle	@x1
	cld
	jmp	@x2
@x1:	add	si,cx
	sub	si,2
	add	di,cx
	sub	di,2
	std
@x2:	shr	cx,1
	cmp	bh,0
	je	@x7
	mov	dx,3dah
	mov	bl,9
@x4:	lodsw
	mov	bp,ax
@x5:	in	al,dx
	rcr	al,1
	jb	@x5
	cli
@x6:	in	al,dx
	and	al,bl
	jz	@x6
	mov	ax,bp
	stosw
	sti
	loop	@x4
	jmp	@x0
@x7:	rep	movsw
@x0:	pop	ds
	pop	bp
	mov	sp,bp
end;

procedure MoveFromScreen(var Source, Destin;
	Count : Word); assembler;
asm
	mov	bp,sp
	push	bp
	push	ds
	mov	bh,ds:CheckSnow
	lds	si,Source
	les	di,Destin
	mov	cx,Count
	jcxz	@x0
	cmp	si,di
	jle	@x1
	cld
	jmp	@x2
@x1:	add	si,cx
	sub	si,2
	add	di,cx
	sub	di,2
	std
@x2:	shr	cx,1
	cmp	bh,0
	je	@x6
	mov	dx,3dah
@x4:	in	al,dx
	and	al,bl
	jb	@x4
	cli
@x5:	in	al,dx
	rcr	al,1
	jnb	@x5
	lodsw
	sti
	stosw
	loop	@x4
	jmp	@x0
@x6:	rep	movsw
@x0:	pop	ds
	pop	bp
	mov	sp,bp
end;

procedure MoveScreen(Source, Destin : Byte);
var
  i : Integer;
  Buf : array [1..2, 1..MaxChar] of Byte;
begin
  if (Source<=MaxPage) and (Destin<=MaxPage) then
    for i:=0 to 24 do
  begin
    MoveFromScreen(VM[PageSize*Source+i*2*MaxChar],Buf,2*MaxChar);
    MoveFromScreen(Buf,VM[PageSize*Destin+i*2*MaxChar],2*MaxChar)
  end
end;

procedure PutScreen(var Source; Page : Byte);
begin
  if Page<=MaxPage then
    MoveToScreen(Source,VM[PageSize*Page],MaxChar*MaxLine*2)
end;

procedure GetScreen(var Destin; Page : Byte);
begin
  if Page<=MaxPage then
    MoveFromScreen(VM[PageSize*Page],Destin,MaxChar*MaxLine*2)
end;

procedure PutChar(Page : Byte; cr : Char); assembler;
asm
	mov	al,Page
	cmp	al,MaxPage
	jae	@x0
	mov	ah,10
	mov	al,cr
	mov	bh,Page
	mov	cx,1
	int	10h
@x0:
end;

procedure GetChar(Page : Byte; var cr : Char;
	var Attr : Byte); assembler;
asm
	mov	al,Page
	cmp	al,MaxPage
	jbe	@x0
	xor	ax,ax
	jmp	@x1
@x0:	mov	bh,al
	mov	ah,8
	int	10h
@x1:	les	di,cr
	stosb
	mov	al,ah
	les	di,Attr
	stosb
end;

procedure PutAttr(Page, Attr : Byte; Count : Word); assembler;
asm
	mov	bl,Attr
	mov	bh,Page
	mov	dx,Count
@x0:	mov	ah,8
	int	10h
	mov	cx,1
	mov	ah,9
	int	10h
	push	dx
	mov	ah,3
	int	10h
	mov	ah,2
	mov	es,Seg0040
	cmp	dh,es:[$4a]
	jbe	@x1
	inc	dh
	xor	dl,dl
@x1:	inc	dl
	int	10h
	pop	dx
	dec	dx
	jnz	@x0
end;

procedure CopyChar(Page : Byte; cr : Char;
	Attr : Byte; Count : Word); assembler;
asm
	mov	al,Page
	cmp	al,MaxPage
	jae	@x0
	mov	cx,Count
	jcxz	@x0
	mov	ah,9
	mov	al,cr
	mov	bl,Attr
	mov	bh,Page
	int	10h
@x0:
end;

procedure Border(x1, y1, x2, y2 : Integer; Bord : BorderType);
const
  c : array [BorderType, 1..6] of Char =
    (('','','','','',''),
     ('','','','','',''),
     (' ',' ',' ',' ',' ',' '));
var x, y, i : Integer;
begin
  if (x1<1) or (x2>MaxChar) or (x1>=x2) or (y1<1) or
    (y2>MaxLine) or (y1>=y2) then Exit;
  x:=WhereX; y:=WhereY;
  GoToXY(x1,y1); Write(c[Bord,1]);
  for i:=1 to x2-x1-1 do Write(c[Bord,2]);
  Write(c[Bord,3]);
  for i:=1 to y2-y1-1 do
  begin
    GoToXY(x1,y1+i); Write(c[Bord,4]);
    GoToXY(x2,y1+i); Write(c[Bord,4])
  end;
  GoToXY(x1,y2); Write(c[Bord,5]);
  for i:=1 to x2-x1-1 do Write(c[Bord,2]);
  PutChar(0,c[Bord,6]); GoToXY(x,y)
end;

procedure SetWindow(x1, y1, x2, y2 : Integer;
	Bord : BorderType);
begin
  if (x1<1) or (x2>MaxChar) or (x1>=x2) or (y1<1) or
    (y2>MaxLine) or (y1>=y2) then Exit;
  Window(x1,y1,x2,y2); ClrScr;
  Border(1,1,x2-x1+1,y2-y1+1,Bord);
  if Bord<>EmptyBorder then
  begin
    if x2-x1>2 then Dec(x2);
    if y2-y1>2 then Dec(y2);
    Window(x1+1,y1+1,x2,y2)
  end;
  GoToXY(1,1)
end;

procedure PutWindow(x1, y1, x2, y2, Text, Back : Byte;
	Bord : BorderType; Page : Byte);
begin
  if (Page>MaxPage) or (Page=0) or (x1<1) or (x2>MaxChar) or
    (x1>=x2) or (y1<1) or (y2>MaxLine) or (y1>=y2) then Exit;
  MoveScreen(0,Page);
  with ScreenAttr[Page] do
  begin
    WindMinSave:=WindMin; WindMaxSave:=WindMax;
    x:=WhereX; y:=WhereY; AttrSave:=TextAttr
  end;
  Colors(Text,Back); SetWindow(x1,y1,x2,y2,Bord)
end;

procedure GetWindow(Page : Byte);
begin
  if (Page>MaxPage) or (Page=0) then Exit;
  MoveScreen(Page,0);
  with ScreenAttr[Page] do
  begin
    WindMin:=WindMinSave; WindMax:=WindMaxSave;
    TextAttr:=AttrSave; GoToXY(x,y)
  end
end;

end { TextCrt }.